

float2 g_CenterTexel;		//u[̒S̃eNZW
float  g_BlurPower;			//ڂx(0.0f Ń{PȂ)
float g_TU = 0.05f;					//Xׂ̗̃eNZʒu
float g_TV = 0.05f;					//Ỹׂ̗eNZʒu

float4 g_Color = float4(1/*R*/, 1/*G*/, 1/*B*/, 1/*A*/);	// 2D`掞ɏZF

float2 g_TexelSize;	// UVWnł̂PsNZ̃TCY...eNZTCY

// ̓eNX`
texture InputTex;
sampler InputSmp = sampler_state
{
	Texture = <InputTex>;
	MinFilter = LINEAR;
	MagFilter = LINEAR;
	MipFilter = NONE;
	AddressU = Clamp;
	AddressV = Clamp;
};



// 2D`PS
float4 NormalPS(float2 UV:TEXCOORD0) : COLOR0
{
	UV += g_TexelSize * 0.5;
	return tex2D(InputSmp, UV) * g_Color;
}

technique NormalTech
{
	pass P0
	{
		PixelShader = compile ps_3_0 NormalPS();
		ZEnable = false;		// Zobt@gȂ
		ZWriteEnable = false;	//
	}
};



struct VS_OUT
{
	float4 Pos : POSITION;
	float2 Tex : TEXCOORD0;
};

VS_OUT VS(
	float4 Pos : POSITION,
	float2 Tex : TEXCOORD0)
{
	VS_OUT Out;

	Out.Pos = Pos;
	Out.Tex = Tex;

	return Out;
}

float4 PS(VS_OUT In) : COLOR0
{
	float4 Color[10];
	
	//u[̒Sʒu  ݂̃eNZʒu
	float2 dir = g_CenterTexel - In.Tex;
	
	//vZ
	float len = length(dir);
	
	//xNg̐KAPeNZ̒ƂȂxNgvZ
	dir = normalize(dir) * float2(g_TU, g_TV);
	
	//g_BlurPower Ń{P𒲐
	//ώZ邱ƂɂA̒Sʒuɋ߂قǃu[̉eȂ悤ɂ
	dir *= g_BlurPower * len;
	
	//
	Color[0] = tex2D(InputSmp, In.Tex) * 0.19f;
	Color[1] = tex2D(InputSmp, In.Tex + dir) * 0.17f;
	Color[2] = tex2D(InputSmp, In.Tex + dir * 2.0f) * 0.15f;
	Color[3] = tex2D(InputSmp, In.Tex + dir * 3.0f) * 0.13f;
	Color[4] = tex2D(InputSmp, In.Tex + dir * 4.0f) * 0.11f;
	Color[5] = tex2D(InputSmp, In.Tex + dir * 5.0f) * 0.09f;
	Color[6] = tex2D(InputSmp, In.Tex + dir * 6.0f) * 0.07f;
	Color[7] = tex2D(InputSmp, In.Tex + dir * 7.0f) * 0.05f;
	Color[8] = tex2D(InputSmp, In.Tex + dir * 8.0f) * 0.03f;
	Color[9] = tex2D(InputSmp, In.Tex + dir * 9.0f) * 0.01f;
	
	return Color[0] + Color[1] + Color[2] + Color[3] + Color[4] + Color[5] + Color[6] + Color[7] + Color[8] + Color[9];
}

technique ShockBlurTech
{
	pass P0
	{
		VertexShader = compile vs_3_0 VS();
		PixelShader = compile ps_3_0 PS();
	}
}